<div class="page-layout carded fullwidth" fusePerfectScrollbar>

  <!-- TOP BACKGROUND -->
  <div class="top-bg {{secondColorBrand}}"></div>
  <!-- / TOP BACKGROUND -->

  <!-- CENTER -->
  <div class="center">

    <!-- HEADER -->
    <div class="header white-fg" fxLayout="row" fxLayoutAlign="space-between center">

      <!-- APP TITLE -->
      <div fxLayout="row" fxLayoutAlign="start center">

        <button class="mr-16" mat-icon-button (click)="routerGoTo()">
          <mat-icon>arrow_back</mat-icon>
        </button>

        <div fxLayout="column" fxLayoutAlign="start start" *fuseIfOnDom [@animate]="{value:'*',params:{delay:'100ms',x:'-25px'}}">
          <div *ngIf="plan && plan.id" class="h2">
            Contrato - {{plan.id}}
          </div>
          <div class="subtitle secondary-text" *ngIf="plan && plan.status">
            <span>{{ planStatusEnumToString(plan.status)}}</span>
          </div>
        </div>

      </div>

      <button type="button" color="primary" mat-raised-button [hidden]="!status" (click)="reactivatePlan()">Reativar
        Plano</button>
      <button type="button" [hidden]="status" color="primary" mat-raised-button (click)="cancelPlan()">Cancelar Plano</button>
      <!-- / APP TITLE -->

    </div>
    <!-- / HEADER -->


    <!-- <div class="center"> -->

    <mat-card>

      <mat-card-content>

        <mat-tab-group>
          <mat-tab>
            <ng-template mat-tab-label>
              <mat-icon>description</mat-icon>
              <span>&nbsp;Contrato</span>
            </ng-template>

            <div class="panel">
              <div class="panel-title" [ngClass]="primaryColorBrand">
                <span>
                  <mat-icon class="white-fg">assignment_ind</mat-icon>
                </span>
                <span class="white-fg">&nbsp;Dados Pessoais</span>
              </div>
              <div class="panel-content">
                <form [formGroup]="generalForm" novalidate>
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Nome" formControlName="name" style="color: black">
                    </mat-form-field>
                    <mat-form-field fxFlex="50">
                      <input type="email" matInput placeholder="E-mail" formControlName="email" style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Tel. Celular" formControlName="mobilePhone" [textMask]="{mask: mobilePhoneMask}"
                        style="color: black">

                    </mat-form-field>

                    <mat-form-field fxFlex="34">
                      <input matInput placeholder="Tel. Residencial" formControlName="residencialPhone" [textMask]="{mask: phoneMask}"
                        style="color: black">

                    </mat-form-field>

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Tel. Comercial" formControlName="commercialPhone" [textMask]="{mask: phoneMask}"
                        style="color: black">

                    </mat-form-field>
                  </div>

                </form>
              </div>
            </div>

            <div class="panel" [style.background-color]="statusPlan">
              <div class="panel-title" [ngClass]="primaryColorBrand">
                <span>
                  <mat-icon class="white-fg">library_books</mat-icon>
                </span>
                <span class="white-fg">&nbsp;Plano</span>
              </div>
              <div class="panel-content">
                <form [formGroup]="planForm" novalidate>
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Nome do Plano" formControlName="name" style="color: black">
                    </mat-form-field>
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Id" formControlName="id" style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="plan && plan['lifecycle'] && plan['lifecycle'].installDate ">

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Instado em" formControlName="installDate" style="color: black"
                        required>
                    </mat-form-field>

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Instado por" formControlName="installUser" style="color: black"
                        required>
                    </mat-form-field>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="plan && plan['lifecycle'] && plan['lifecycle'].cancelDate ">

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Cancelado em" formControlName="cancelDate" style="color: black"
                        required>
                    </mat-form-field>

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Cancelado por" formControlName="cancelUser" style="color: black"
                        required>
                    </mat-form-field>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px" *ngIf="plan && plan['lifecycle'] && plan['lifecycle'].reactivateDate ">

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Reativado em" formControlName="reactivateDate" style="color: black"
                        required>
                    </mat-form-field>

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Reativado por" formControlName="reactivateUser" style="color: black"
                        required>
                    </mat-form-field>

                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Status do Plano" formControlName="planStatus" style="color: black">
                    </mat-form-field>
                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Status do Pagamento" formControlName="paymentStatus" style="color: black">
                    </mat-form-field>
                  </div>


                </form>
              </div>
            </div>

            <div class="panel">
              <div class="panel-title" [ngClass]="primaryColorBrand">
                <mat-icon class="white-fg">directions_car</mat-icon>
                <span class="white-fg">&nbsp;Veículo</span>
              </div>

              <div class="panel-content">
                <form [formGroup]="vehicleForm">
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Marca" formControlName="manufacturer" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Modelo" formControlName="model" required style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Ano de fabricação" formControlName="manufacturerYear" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="34">
                      <input matInput placeholder="Ano do modelo" formControlName="modelYear" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Cor" formControlName="color" required style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Placa" formControlName="licensePlate" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Chassi" formControlName="chassi" required style="color: black">
                    </mat-form-field>
                  </div>

                </form>
              </div>

            </div>

            <div class="panel" *ngIf="plan && plan.relationships">
              <div class="panel-title" [ngClass]="primaryColorBrand">
                <mat-icon class="white-fg">gps_fixed</mat-icon>
                <span class="white-fg">&nbsp;Rastreador</span>
              </div>

              <div class="panel-content">
                <form [formGroup]="deviceForm">
                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Modelo" formControlName="model" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="50">
                      <input matInput placeholder="Status" formControlName="status" required style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Operadora" formControlName="operator" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="34">
                      <input matInput placeholder="Número" formControlName="number" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Sim-Card" formControlName="simCard" required style="color: black">
                    </mat-form-field>
                  </div>

                  <div fxLayout="row" fxLayoutAlign="start center" fxLayoutGap="10px">

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Id" formControlName="id" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="33">
                      <input matInput placeholder="Identificador" formControlName="identifier" required style="color: black">
                    </mat-form-field>

                    <mat-form-field fxFlex="34">
                      <input matInput placeholder="imei" formControlName="imei" required style="color: black">
                    </mat-form-field>
                  </div>

                </form>
              </div>

            </div>

            <br>
            <div fxLayout="row" fxLayoutAlign="end center" fxLayoutGap="10px">
              <!-- <button type="button" mat-raised-button (click)="cancel()">Voltar</button> -->
              <button type="button" color="primary" mat-raised-button [hidden]="!status" (click)="reactivatePlan()">Reativar
                Plano</button>
              <button type="button" [hidden]="status" color="primary" mat-raised-button (click)="cancelPlan()">Cancelar
                Plano</button>
            </div>

          </mat-tab>
          <mat-tab *ngIf="planChargesDataSource && planChargesDataSource.length > 0">
            <ng-template mat-tab-label>
              <span>
                <mat-icon>local_atm</mat-icon>
              </span>
              <span>&nbsp;Cobranças</span>
            </ng-template>

            <div class="panel">
              <div class="panel-title" [ngClass]="primaryColorBrand">
                <span>
                  <mat-icon class="white-fg">local_atm</mat-icon>
                </span>
                <span class="white-fg">&nbsp;Cobranças</span>
              </div>

              <div class="panel-content">

                <table class="simple">
                  <thead>
                    <tr>
                      <th>Tipo</th>
                      <th>Vencimento</th>
                      <th>Processamento</th>
                      <th>Tipo de Pagamento</th>
                      <th *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type == 'CREDIT_CARD'">Parcelamento</th>
                      <th>Bandeira</th>
                      <th>Número</th>
                      <th>Valor</th>
                      <th>Status</th>
                      
                      <!-- <th>Tentativas</th> -->
                      <th>Logs da Cobranças</th>
                      <th>Editar Pagamento</th>
                      <!-- <th  style="text-align: center">Nova Tentativa</th>
                                                            <th  style="text-align: center">Gerar Boleto</th> -->
                      <!-- *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type == 'BOOKLET'" *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type == 'BOOKLET'" -->

                    </tr>
                  </thead>
                  <tbody>
                    <tr *ngFor="let charge of planChargesDataSource; let i = index">
                      <td>
                        {{ ChargeTypeCardEnumToString(charge.type) }}
                      </td>
                      <td>
                        {{charge.ref ? charge.ref : '-'}}
                      </td>
                      <td>
                        {{charge.scheduledDateTime | date: 'dd/MM/yyyy'}}
                      </td>
                      <td>
                        {{ PaymentTypeEnumToString(plan.relationships?.payment ? charge.payment.type :
                        charge.paymentType) }}
                      </td>
                      <td *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type == 'CREDIT_CARD'">
                        <span *ngIf="charge.installments > 1">Parcelado em&nbsp;{{charge.installments}}x</span>
                        <span *ngIf="charge.installments == 1">Á vista</span>
                      </td>
                      <td>
                        {{ plan.relationships?.payment ? charge.payment.creditCardBrand ?
                        charge.payment.creditCardBrand : charge.payment.debitCardBrand ? charge.payment.debitCardBrand
                        : '-' : '-'}}
                      </td>
                      <td>
                        {{ plan.relationships?.payment ? charge.payment.creditCardNumber ?
                        charge.payment.creditCardNumber : charge.payment.debitCardNumber ?
                        charge.payment.debitCardNumber : '-' : '-'}}
                      </td>
                      <td>
                        {{charge.amount | currency: 'BRL'}}
                      </td>
                      <td>
                        {{ PaymentCreditCardEnumToString(charge.status) }}
                      </td>
                      
                      
                      <td>
                        <button type="button" mat-icon-button color="accent" (click)="loadChargeLog(charge)" matTooltip="Logs da Cobranças">
                          Logs da Cobranças
                        </button>
                      </td>

                      <td style="text-align: center">


                        <!-- <button mat-icon-button [matMenuTriggerFor]="card20Menu" aria-label="more" fxLayoutAlign="end center" style="padding-left: 50px">
                                                                            <mat-icon *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type == 'BOOKLET'">library_books</mat-icon> 
                                                                            <mat-icon *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type != 'BOOKLET'">credit_card</mat-icon> 
                                                                        </button> -->
                        <button mat-raised-button fxLayoutAlign="end center" [matMenuTriggerFor]="card20Menu" [ngClass]="primaryColorBrand">
                          <mat-icon *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type == 'BOOKLET'">library_books</mat-icon>
                          <mat-icon *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type != 'BOOKLET'">credit_card</mat-icon>
                          &nbsp;&nbsp;&nbsp;&nbsp;Editar
                        </button>

                        <mat-menu #card20Menu="matMenu">
                          <button fxLayout="row" fxLayoutAlign="start center" mat-menu-item *ngIf="!charge.bookletUrl && charge.paymentType != 'BOOKLET' && ((charge.status == 'FAILED') || (charge.status == 'FAIL'))"
                            (click)="sendBooklet(charge.id,i,charge)">
                            <mat-icon>cloud_download</mat-icon>
                            <span>Mudar para Boleto</span>
                          </button>
                          <button fxLayout="row" fxLayoutAlign="start center" *ngIf="charge.bookletUrl || charge.paymentType == 'BOOKLET'"
                            mat-menu-item (click)="sendBooklet(charge.id,i,charge)">
                            <mat-icon>cloud_download</mat-icon>
                            <span>Imprimir Boleto</span>
                          </button>
                          <button fxLayout="row" fxLayoutAlign="start center" *ngIf="(plan.relationships?.payment && plan.relationships?.payment?.type != 'BOOKLET' && ((charge.status == 'FAILED') || (charge.status == 'FAIL')))"
                            mat-menu-item (click)="chargesRetry(charge.id,i)">
                            <mat-icon>repeat</mat-icon>
                            <span>Nova Tentativa</span>
                          </button>
                          <button fxLayout="row" fxLayoutAlign="start center" disabled="true" mat-menu-item>
                            <mat-icon>monetization_on</mat-icon>
                            <span>Definir Como Recebido</span>
                          </button>

                        </mat-menu>


                      </td>
                      <!-- <td  style="text-align: center">
                                                                <mat-icon style="cursor:pointer" *ngIf="charge.bookletUrl" class="m-0 mr-16" (click)="downloadBooklet(charge.bookletUrl)">cloud_download</mat-icon>
                                                            </td>   
                                                            <td  style="text-align:center">
                                                                <mat-icon style="cursor:pointer" class="m-0 mr-16" *ngIf="((charge.status == 'FAILED') || (charge.status == 'FAIL')) && (plan.relationships?.payment && plan.relationships?.payment?.type != 'BOOKLET')" (click)="chargesRetry(charge.id,i)">repeat</mat-icon>
                                                            </td>    
                                                            <td  style="text-align:center">
                                                                <mat-icon style="cursor:pointer" class="m-0 mr-16" *ngIf="(charge.status == 'FAILED') || (charge.status == 'FAIL')"  (click)="sendBooklet(charge.id,i)">receipt</mat-icon>
                                                            </td>      -->

                      <!-- *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type == 'BOOKLET'" *ngIf="plan.relationships?.payment && plan.relationships?.payment?.type != 'BOOKLET'"-->
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>

            <div class="panel">
              <div class="panel-title" [ngClass]="primaryColorBrand">
                <span>
                  <mat-icon class="white-fg">local_atm</mat-icon>
                </span>
                <span class="white-fg">&nbsp;Logs da Cobrança</span>
              </div>
              <div class="panel-content">

                <table class="simple">
                  <thead>
                    <tr>
                      <th>Data</th>
                      <th>Status</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr *ngFor="let item of planChargeLogsDataSource">
                      <td>
                        {{item.dateTime | date: 'short'}}
                      </td>
                      <td>
                        {{item.text}}
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>


          </mat-tab>
          <mat-tab *ngIf="planChargesDataSource && planChargesDataSource.length > 0">
            <ng-template mat-tab-label>
              <span>
                <mat-icon>payment</mat-icon>
              </span>
              <span>&nbsp;Formas de Pagamento</span>
            </ng-template>

            <div  fxLayoutGap="10px">

              <div fxFlex="70">

                <div class="panel">
                  <div class="panel-title" [ngClass]="primaryColorBrand">
                    <span>
                      <mat-icon class="white-fg">payment</mat-icon>
                    </span>
                    <span class="white-fg">&nbsp;Forma de Pagamento</span>

                  </div>

                  <div class="panel-content">


                    <table class="simple">
                      <thead>
                        <tr>
                          <th>Tipo de Pagamento</th>
                          <th>Bandeira</th>
                          <th>Número</th>
                        </tr>
                      </thead>
                      <tbody>
                        <tr>
                          <td>
                            {{ PaymentTypeEnumToString(plan.relationships?.payment ?
                            planChargesDataSource[0].payment.type : planChargesDataSource[0].paymentType) }}
                          </td>
                          <td>
                            {{ plan.relationships?.payment ? planChargesDataSource[0].payment.creditCardBrand ?
                            planChargesDataSource[0].payment.creditCardBrand :
                            planChargesDataSource[0].payment.debitCardBrand ?
                            planChargesDataSource[0].payment.debitCardBrand : '-' : '-'}}
                          </td>
                          <td>
                            {{ plan.relationships?.payment ? planChargesDataSource[0].payment.creditCardNumber ?
                            planChargesDataSource[0].payment.creditCardNumber :
                            planChargesDataSource[0].payment.debitCardNumber ?
                            planChargesDataSource[0].payment.debitCardNumber : '-' : '-'}}
                          </td>
                        </tr>
                      </tbody>
                    </table>




                  </div>
                </div>
              </div>
              <div fxFlex="30">
                <div class="panel">
                  <div class="panel-title" [ngClass]="primaryColorBrand">
                    <span>
                      <mat-icon class="white-fg">payment</mat-icon>
                    </span>
                    <span class="white-fg">&nbsp;Mudar Forma de Pagamento</span>
                  </div>

                  <div class="panel-content">
                    <tnm-payments (onPaymentTypeChanged)="onPaymentTypeChanged($event)"></tnm-payments>
                  </div>
                </div>

              </div>
            </div>

           
          </mat-tab>

        </mat-tab-group>

      </mat-card-content>
    </mat-card>


  </div>
</div>
